from pypika.terms import Function, JSON


class Timezone(Function):
    def __init__(self, timezone, date, alias=None):
        super(Timezone, self).__init__('TIMEZONE', timezone, date, alias=alias)


class Text(Function):
    def __init__(self, text, alias=None):
        super(Text, self).__init__('TEXT', text, alias=alias)


class Cast(Function, JSON):
    def __init__(self, term, as_type, alias=None):
        super(Cast, self).__init__("CAST", term, alias=alias)
        self.as_type = as_type

    def get_special_params_sql(self, **kwargs):
        type_sql = (
            self.as_type.get_sql(**kwargs)
            if hasattr(self.as_type, "get_sql")
            else str(self.as_type).upper()
        )

        return "AS {type}".format(type=type_sql)


class DatePart(Function):
    def __init__(self, text, date, alias=None):
        super(DatePart, self).__init__('DATE_PART', text, date, alias=alias)