from fireant.database import MySQLDatabase, PostgreSQLDatabase
from google.cloud import secretmanager
import json


# ----------------------------------------------------------------------
#  Main Data Science AWS DB 
client = secretmanager.SecretManagerServiceClient()
secret = f'projects/fave-data/secrets/rds-warehouse/versions/1'
payload = json.loads(
    client.access_secret_version(secret).payload.data.decode('utf-8')
)
postgres_user = payload.get('user')
postgres_password = payload.get('password')
postgres_database = payload.get('database')


rds_warehouse = PostgreSQLDatabase(
    database=postgres_database,
    host='10.148.15.219',
    port=5432,
    user=postgres_user,
    password=postgres_password,
)

# ----------------------------------------------------------------------
# Destination DB for streaming/Source for bi_dwh.ref_cities
secret = 'projects/fave-data/secrets/cloudsql-warehouse/versions/1'
payload = json.loads(
    client.access_secret_version(secret).payload.data.decode('utf-8')
)
gcp_postgres_user = payload.get('user')
gcp_postgres_password = payload.get('password')
gcp_postgres_database = payload.get('database')


gcp_replica = PostgreSQLDatabase(
    database=gcp_postgres_database,
    host='10.46.192.5',
    port=5432,
    user=gcp_postgres_user,
    password=gcp_postgres_password,
)

# ----------------------------------------------------------------------
# to merge with other tables
secret = 'projects/fave-data/secrets/rds-production-replica/versions/1'
payload = json.loads(
    client.access_secret_version(secret).payload.data.decode('utf-8')
)
prod_postgres_user = payload.get('user')
prod_postgres_password = payload.get('password')
prod_postgres_database = payload.get('database')


rds_replica = PostgreSQLDatabase(
    database=prod_postgres_database,
    host='10.148.15.219',
    port=5434,
    user=prod_postgres_user,
    password=prod_postgres_password,
)

# ----------------------------------------------------------------------
# to merge with other tables
secret = 'projects/fave-data/secrets/rds-mysql-favefood/versions/1'
payload = json.loads(
    client.access_secret_version(secret).payload.data.decode('utf-8')
)
mysql_user = payload.get('user')
mysql_password = payload.get('password')
mysql_database = payload.get('database')


mysql_replica = MySQLDatabase(
    database=mysql_database,
    host='10.148.15.219',
    port=3306,
    user=mysql_user,
    password=mysql_password,
)
